;**************************************************************
;     PB-Declarer
;
; Autor: Josef Sniatecki
; Date: 08.11.2009
;   Josef Sniatecki 2009 (c)
;**************************************************************



Global Parameter.s, FileName.s
Global File.i
Global LineStart.i, LineEnd.i

Global Index.i
Global Line.s, *Char.Character

Global Result.s



; Get informations form PureBasic:
Parameter = ProgramParameter()
FileName  = ProgramParameter()

; Get selection dimensions:
LineStart   = Val(StringField(Parameter, 1, "x")) - 1
LineEnd     = Val(StringField(Parameter, 3, "x")) - 1

; Open file:
File = ReadFile(#PB_Any, FileName)
If Not File
  MessageRequester("Error", "Can not read file: " + Chr(34) + FileName + Chr(34))
  End
EndIf


; Move to the start:
For Index = 1 To LineStart
  ReadString(File)
Next



Index = LineStart
While Index <= LineEnd
  Line = Trim(ReadString(File))
  If Line = ""
    Result + Chr(13) + Chr(10)
  ElseIf LCase(Left(Line, 9)) = "procedure" And Not LCase(Left(Line, 15)) = "procedurereturn"
    *Char = @Line + 9
    Repeat
      Select *Char\c
        Case 0, 13, 10
          Break
        Case '"'
          Repeat
            *Char + 1
          Until *Char\c = '"'
        Case ';'
          Break
      EndSelect
      *Char + 1
    ForEver
    If Result
      Result + Chr(13) + Chr(10)
    EndIf
    Result + "Declare" + PeekS(@Line + 9, *Char - (@Line + 9))
    Repeat
      Index + 1
    Until Index > LineEnd Or LCase(Left(Trim(ReadString(File)), 12)) = "endprocedure"
  EndIf
  Index + 1
Wend



SetClipboardText(Result)
End
; IDE Options = PureBasic 4.40 Beta 6 (Windows - x86)
; CursorPosition = 47
; FirstLine = 42
; EnableXP
; Executable = PB-Declarer.exe